/*
 * AMIGA_Window.h - class definition amiga window support.
 *
 * Copyright (C) 1992, Lucas Ammon
 *                     University of Berne, Switzerland
 * All rights reserved.
 *
 * This software may be freely copied, modified, and redistributed
 * provided that this copyright notice is preserved on all copies.
 *
 * You may not distribute this software, in whole or in part, as part of
 * any commercial product without the express consent of the authors.
 *
 * There is no warranty or other guarantee of fitness of this software
 * for any purpose.  It is provided solely "as is".
 *
 */

#ifndef AMIGA_Window_H
# define AMIGA_Window_H

#include <intuition/intuition.h>

extern "C" OpenLibrary(...);
extern "C" CloseLibrary(...);
extern "C" GetMsg(...);
extern "C" ReplyMsg(...);
extern "C" OpenWindow(...);
extern "C" CloseWindow(...);
extern "C" PrintIText(...);
extern "C" SetRast(...);
extern "C" Move(...);
extern "C" Draw(...);
extern "C" SetAPen(...);
extern "C" SetBPen(...);

#include "BaseWindow.h"

//___________________________________________________________ AMIGA_Window

class AMIGA_Window : public BaseWindow
{
public:
  AMIGA_Window();

  void open(int resX, int resY, const rcString& windowName);
  void close();
  void clear();
  char waitForKey();
  void writeText(const rcString&, int, int);

protected:
  void drawLine(int, int, int, int);
  void flush();

private:
  struct RastPort *rp;
  struct Window *w;
  struct IntuiMessage *message;
  struct IntuitionBase *intuitionbase; 
  struct GfxBase *gfxbase;
  rcString WindowName;
  int w_xres, w_yres;
};

struct IntuitionBase *IntuitionBase; 
struct GfxBase *GfxBase;


#endif // AMIGA_Window_H
