/*
 * BBoxDevice.C - bounding box device driver.
 *
 * Copyright (C) 1992, Christoph Streit (streit@iam.unibe.ch)
 *                     University of Berne, Switzerland
 * All rights reserved.
 *
 * This software may be freely copied, modified, and redistributed
 * provided that this copyright notice is preserved on all copies.
 *
 * You may not distribute this software, in whole or in part, as part of
 * any commercial product without the express consent of the authors.
 *
 * There is no warranty or other guarantee of fitness of this software
 * for any purpose.  It is provided solely "as is".
 *
 */

#include "BBoxDevice.h"
#include "ViewTransform.h"

//___________________________________________________________ BBoxDevice

BBoxDevice::BBoxDevice(Options* options)
: DeviceDriver(options)
{}

void BBoxDevice::begin(){}

/*
 * The only thing we have to do, is wait und report the bounding box.
 */
void BBoxDevice::end(const BoundingBox& b)
{ 
  cout << "BoundingBox: "
       << b << "\n\n";
  ViewTransform* view = new ViewTransform(b, theOptions->up, theOptions->fov,
					  theOptions->resX, theOptions->resY);    
  cout << "proposed view parameter:\n"
       << *view << '\n';

  delete view;
}

void BBoxDevice::cylinder(const Vector&, const Vector&, real){}
void BBoxDevice::cone(const Vector&, real, const Vector&, real){}
void BBoxDevice::sphere(const Vector&, real){}
void BBoxDevice::polygon(Polygon*){}


