/*
 * BBoxDevice.h  - class definition for bounding box device driver.
 *
 * Copyright (C) 1992, Christoph Streit (streit@iam.unibe.ch)
 *                     University of Berne, Switzerland
 * All rights reserved.
 *
 * This software may be freely copied, modified, and redistributed
 * provided that this copyright notice is preserved on all copies.
 *
 * You may not distribute this software, in whole or in part, as part of
 * any commercial product without the express consent of the authors.
 *
 * There is no warranty or other guarantee of fitness of this software
 * for any purpose.  It is provided solely "as is".
 *
 */

#ifndef BBoxDevice_H
# define BBoxDevice_H

#include "DeviceDriver.h"

/*___________________________________________________________ BBoxDevice
 *
 * Don't do any graphic stuff. Just calculate the bounding box
 * of the object.
 */

class BBoxDevice : public DeviceDriver 
{
public:
  BBoxDevice(Options*);

  void begin();
  void end(const BoundingBox&);
  void cylinder(const Vector&, const Vector&, real);
  void cone(const Vector&, real, const Vector&, real);
  void sphere(const Vector&, real);
  void polygon(Polygon*);
};

#endif // BBoxDevice_H


