/*
 * Cone.h  - class definition for geometric object cone.
 *
 * Copyright (C) 1992, Christoph Streit (streit@iam.unibe.ch)
 *                     University of Berne, Switzerland
 * Copyright (C) 1989, 1991, Craig E. Kolb
 * All rights reserved.
 *
 * This software may be freely copied, modified, and redistributed
 * provided that this copyright notice is preserved on all copies.
 *
 * You may not distribute this software, in whole or in part, as part of
 * any commercial product without the express consent of the authors.
 *
 * There is no warranty or other guarantee of fitness of this software
 * for any purpose.  It is provided solely "as is".
 *
 */

#ifndef Cone_H
# define Cone_H

#include "GeoObject.h"
#include "Polygon.h"

//___________________________________________________________ Cone

class Cone : public GeoObject 
{
public:
  static GeoObject* create(real, const Vector&, real, const Vector&);

  int intersect(const Ray&, real, real&);
  Vector normal(const Vector&) const;
  PolygonList* tesselate(const BoundingBox&);

  int setTransform(TransMatrix*);
  
private:
  Cone(real, const Vector&, real, const Vector&);

private:
  /*
   * startDistance is the distance from the origin of the canonical
   * cone at which the cone begins
   */
  real startDistance;
};

#endif // Cone_H
