/*
 * DeviceDriver.C - abstract base class for device drivers.
 *
 * Copyright (C) 1992, Christoph Streit (streit@iam.unibe.ch)
 *                     University of Berne, Switzerland
 * All rights reserved.
 *
 * This software may be freely copied, modified, and redistributed
 * provided that this copyright notice is preserved on all copies.
 *
 * You may not distribute this software, in whole or in part, as part of
 * any commercial product without the express consent of the authors.
 *
 * There is no warranty or other guarantee of fitness of this software
 * for any purpose.  It is provided solely "as is".
 *
 */

#include "DeviceDriver.h"

//___________________________________________________________ DeviceDriver

implementTable(StringTable, rcString, anyPtr);

DeviceDriver::DeviceDriver()
: primitives(0), LSystemName("Noname"),
  definingMacro(0), macroNames(103), libraryNames(103),
  theOptions(NULL)
{}

DeviceDriver::DeviceDriver(Options* options)
: primitives(0), LSystemName("Noname"),
  definingMacro(0), macroNames(103), libraryNames(103),
  theOptions(options)
{}

DeviceDriver::~DeviceDriver(){}

void DeviceDriver::color(const Color&) {}
void DeviceDriver::texture(const rcString&) {}
void DeviceDriver::beginMacro(const rcString&)
{
  definingMacro = 1;
}
void DeviceDriver::endMacro()
{
  definingMacro = 0;
}
void DeviceDriver::executeMacro(const rcString&, const TransMatrix&){}
void DeviceDriver::libraryObject(const rcString&, const TransMatrix&){}

int DeviceDriver::addMacroName(const rcString& macroName)
{
  return macroNames.insert(macroName, NULL);
}

void DeviceDriver::addLibraryObjectName(const rcString& libName)
{
  libraryNames.insert(libName, NULL);
}

void DeviceDriver::setName(const rcString& name)
{
  LSystemName = name;
}



