/*
 * ExampleDevice.h - class definition of example device driver.
 *
 * Copyright (C) 1992, Christoph Streit (streit@iam.unibe.ch)
 *                     University of Berne, Switzerland
 * All rights reserved.
 *
 * This software may be freely copied, modified, and redistributed
 * provided that this copyright notice is preserved on all copies.
 *
 * You may not distribute this software, in whole or in part, as part of
 * any commercial product without the express consent of the authors.
 *
 * There is no warranty or other guarantee of fitness of this software
 * for any purpose.  It is provided solely "as is".
 *
 */

#ifndef ExampleDevice_H
# define ExampleDevice_H

#include "DeviceDriver.h"

//___________________________________________________________ ExampleDevice

class ExampleDevice : public DeviceDriver 
{
public:
  ExampleDevice();

  void begin();
  void end(const BoundingBox&);
  void cylinder(const Vector&, const Vector&, real);
  void cone(const Vector&, real, const Vector&, real);
  void sphere(const Vector&, real);
  void polygon(Polygon*);
};

#endif // ExampleDevice_H


