/*
 * Options.h - collection of program options.
 *
 * Copyright (C) 1992, Christoph Streit (streit@iam.unibe.ch)
 *                     University of Berne, Switzerland
 * All rights reserved.
 *
 * This software may be freely copied, modified, and redistributed
 * provided that this copyright notice is preserved on all copies.
 *
 * You may not distribute this software, in whole or in part, as part of
 * any commercial product without the express consent of the authors.
 *
 * There is no warranty or other guarantee of fitness of this software
 * for any purpose.  It is provided solely "as is".
 *
 */

#ifndef Options_H
# define Options_H

#include "rcString.h"
#include "Vector.h"

//___________________________________________________________ Options

class Expression;
class HullSymtab;

struct Options
{
  Options();

  rcString iname;
  rcString oname;
  rcString drivername;
  rcString optionsForCPP;

  int      verbose;
  int      quiet;
  int      printlsys;
  int      printModules;
  int      deleteModules;
  int      resX;
  int      resY;
  Vector   eye;
  Vector   lookat;
  Vector   up;
  double   fov;
  int      autoscale;
  int      coneSpheres;
  int      showHulls;
  int      coneResolution;
  int      sphereResolution;

  real defaultForward;
  real defaultPitch;
  real defaultTurn;
  real defaultRoll;

  Expression* tropismX;
  Expression* tropismY;
  Expression* tropismZ;
  Expression* weight;
  HullSymtab* hulls;
};

extern Options theOptions;

void parseOptions(int, char**);

#endif // Options_H
