/*
 * Predecessor.C - methods for L-System predecessors.
 *
 * Copyright (C) 1992, Christoph Streit (streit@iam.unibe.ch)
 *                     University of Berne, Switzerland
 * All rights reserved.
 *
 * This software may be freely copied, modified, and redistributed
 * provided that this copyright notice is preserved on all copies.
 *
 * You may not distribute this software, in whole or in part, as part of
 * any commercial product without the express consent of the authors.
 *
 * There is no warranty or other guarantee of fitness of this software
 * for any purpose.  It is provided solely "as is".
 *
 */

#include "Predecessor.h"

//___________________________________________________________ Predecessor

Predecessor::Predecessor(const Name& n, NameList* param)
: name(n), formalParam(param)
{}

Predecessor::~Predecessor()
{
  if (formalParam) {
    for (long i=0; i<formalParam->count(); i++)
      delete formalParam->item(i);
    delete formalParam;
  }
}

