/*
 * Predecessor.h - class definition for L-System predecessors.
 *
 * Copyright (C) 1992, Christoph Streit (streit@iam.unibe.ch)
 *                     University of Berne, Switzerland
 * All rights reserved.
 *
 * This software may be freely copied, modified, and redistributed
 * provided that this copyright notice is preserved on all copies.
 *
 * You may not distribute this software, in whole or in part, as part of
 * any commercial product without the express consent of the authors.
 *
 * There is no warranty or other guarantee of fitness of this software
 * for any purpose.  It is provided solely "as is".
 *
 */

#ifndef Predecessor_H
# define Predecessor_H

#include "Module.h"
#include "Name.h"

//___________________________________________________________ Predecessor

class Production;
class ostream;

class Predecessor
{
  friend class Production;
  friend ostream& operator<<(ostream&, Production&);

public:
  Predecessor(const Name&, NameList*);
  ~Predecessor();

private:
  Name name; 
  NameList* formalParam; // we need the names of the formal parameters
                         // for the << operator of class Production.
};

#endif // Predecessor_H
