/*
 * X11_Window.h - class definition x11 window support.
 *
 * Copyright (C) 1992, Christoph Streit (streit@iam.unibe.ch)
 *                     University of Berne, Switzerland
 * All rights reserved.
 *
 * This software may be freely copied, modified, and redistributed
 * provided that this copyright notice is preserved on all copies.
 *
 * You may not distribute this software, in whole or in part, as part of
 * any commercial product without the express consent of the authors.
 *
 * There is no warranty or other guarantee of fitness of this software
 * for any purpose.  It is provided solely "as is".
 *
 */

#ifndef X11_Window_H
# define X11_Window_H

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xatom.h>

#include "BaseWindow.h"

//___________________________________________________________ X11_Window

class X11_Window : public BaseWindow
{
public:
  X11_Window();

  void open(int resX, int resY, const rcString& windowName);
  void close();
  void clear();
  char waitForKey();
  void writeText(const rcString&, int, int);

protected:
  void drawLine(int, int, int, int);
  void flush();

private:
  Display* display;
  Window win;
  char* display_name;
  GC gc;
  XSegment* segments;
  long RequestSize;
  int segmentsInBuffer;
};

#endif // X11_Window_H
