/*
 * transform.h
 *
 * Copyright (C) 1992, Christoph Streit (streit@iam.unibe.ch)
 *                     University of Berne, Switzerland
 * Copyright (C) 1989, 1991, Craig E. Kolb
 * All rights reserved.
 *
 * This software may be freely copied, modified, and redistributed
 * provided that this copyright notice is preserved on all copies.
 *
 * You may not distribute this software, in whole or in part, as part of
 * any commercial product without the express consent of the authors.
 *
 * There is no warranty or other guarantee of fitness of this software
 * for any purpose.  It is provided solely "as is".
 *
 */

#ifndef Transform_H
# define Transform_H

#include "Vector.h"
#include "TransMatrix.h"

Vector normalTransform(const Vector&, const TransMatrix&);
Vector vectorTransform(const Vector&, const TransMatrix&);
Vector pointTransform(const Vector&, const TransMatrix&);
TransMatrix coordSystemTransform(const Vector& orig, Vector up, real r, real l);

#endif // Transform_H
